# all files / ol/proj/ proj.js

92.95% Statements 211/227
89.66% Branches 78/87
90.91% Functions 40/44
92.95% Lines 211/227

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344
    345
    346
    347
    348
    349
    350
    351
    352
    353
    354
    355
    356
    357
    358
    359
    360
    361
    362
    363
    364
    365
    366
    367
    368
    369
    370
    371
    372
    373
    374
    375
    376
    377
    378
    379
    380
    381
    382
    383
    384
    385
    386
    387
    388
    389
    390
    391
    392
    393
    394
    395
    396
    397
    398
    399
    400
    401
    402
    403
    404
    405
    406
    407
    408
    409
    410
    411
    412
    413
    414
    415
    416
    417
    418
    419
    420
    421
    422
    423
    424
    425
    426
    427
    428
    429
    430
    431
    432
    433
    434
    435
    436
    437
    438
    439
    440
    441
    442
    443
    444
    445
    446
    447
    448
    449
    450
    451
    452
    453
    454
    455
    456
    457
    458
    459
    460
    461
    462
    463
    464
    465
    466
    467
    468
    469
    470
    471
    472
    473
    474
    475
    476
    477
    478
    479
    480
    481
    482
    483
    484
    485
    486
    487
    488
    489
    490
    491
    492
    493
    494
    495
    496
    497
    498
    499
    500
    501
    502
    503
    504
    505
    506
    507
    508
    509
    510
    511
    512
    513
    514
    515
    516
    517
    518
    519
    520
    521
    522
    523
    524
    525
    526
    527
    528
    529
    530
    531
    532
    533
    534
    535
    536
    537
    538
    539
    540
    541
    542
    543
    544
    545
    546
    547
    548
    549
    550
    551
    552
    553
    554
    555
    556
    557
    558
    559
    560
    561
    562
    563
    564
    565
    566
    567
    568
    569
    570
    571
    572
    573
    574
    575
    576
    577
    578
    579
    580
    581
    582
    583
    584
    585
    586
    587
    588
    589
    590
    591
    592
    593
    594
    595
    596
    597
    598
    599
    600
    601
    602
    603
    604
    605
    606
    607
    608
    609
    610
    611
    612
    613
    614
    615
    616
    617
    618
    619
    620
    621
    622
    623
    624
    625
    626
    627
    628
    629
    630
    631
    632
    633
    634
    635
    636
    637
    638
    639
    640
    641
    642
    643
    644
    645
    646
    647
    648
    649
    650
    651
    652
    653
    654
    655
    656
    657
    658
    659
    660
    661
    662
    663
    664
    665
    666
    667
    668
    669
    670
    671
    672
    673
    674
    675
    676
    677
    678
    679
    680
    681
    682
    683
    684
    685
    686
    687
    688
    689
    690
    691
    692
    693
    694
    695
    696
    697
    698
    699
    700
    701
    702
    703
    704
    705
    706
    707
    708
    709
    710
    711
    712
    713
    714
    715
    716
    717
    718
    719
    720
    721
    722
    723
    724
    725
    726
    727
    728
    729
    730
    731
    732
    733
    734
    735
    736
    737
    738
    739
    740
    741
    742
    743
    744
    745
    746
    747
    748
    749
    750
    751
    752
    753
    754
    755
    756
    757
    758
    759
    760
    761
    762
    763
    764
    765
    766
    767
    768
    769
    770
    771
    772
    773
    774
    775
    776
    777
    778
    779
    780
    781
    782
    783
    784
    785
    786
    787
    788
    789
    790
    791
    792
    793
    794
    795
    796
    797
    798
    799
    800
    801
    802
    803
    804
    805
    806
    807
    808
    809
    810
    811
    812
    813
    814
    815
    816
    817
    818
    819
    820
    821
    822
    823
    824
    8251×
    1×
    1×
    1×
    1×

    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×

    1×

    1×
    1×

    1×
    1×
    1×

    1×

    61×

    61×

    61×

    61×

    61×

    61×

    61×

    61×

    61×

    61×
    61×
    61×

    61×

    53×
    53×
    29×
    12×

    29×
    25×
    25×
    5×

    3×
    3×

    25×

    29×
    29×
    380×
    380×
    104×
    104×
    32×

    72×
    72×

    1×
    416×

    1×
    24363×

    1×
    489×

    1×
    637×

    1×
    534×

    1×
    1×

    1×
    2663×

    1×
    592×

    1×
    2×
    2×

    1×
    34×

    1×
    4×

    1×
    10×
    10×

    1×

    1×

    1×
    486×
    486×

    486×

    486×

    486×
    486×

    486×

    486×
    486×
    486×
    484×

    486×

    1×
    486×

    1×

    1×

    1×
    124×
    124×
    754×
    5326×
    4572×

    1×

    46×
    368×
    2576×
    2576×

    1×
    780×
    780×

    1×
    124×
    124×
    754×

    1×
    44×
    44×

    1×
    271×
    128×
    143×
    142×

    1×

    1×

    1×
    10651×
    10651×
    10651×
    10651×
    702×

    10651×

    1×

    73×
    73×
    73×

    73×

    1×
    146×

    555×
    555×
    555×
    555×
    555×
    2018×
    2018×
    2018×
    2018×
    6×

    555×

    1×
    3×
    3×
    3×
    3×

    3×

    3×
    3×
    3×
    1×

    3×

    1×
    2×

    1×
    2×

    1×
    6544×
    6544×
    873×
    5671×
    4523×
    4523×
    4523×

    25×
    25×

    1148×

    6544×

    1×
    163×
    44×
    119×
    2×

    117×

    117×

    1×
    390×
    390×
    390×

    1×

    997×
    997×
    997×
    997×
    997×

    997×

    997×

    997×

    1×

    1×
    14×
    14×

    14×

    14×

    1×
    267×
    267×

    1×
    10×
    10×

    1×

     goog.provide('ol.proj');
    goog.provide('ol.proj.METERS_PER_UNIT');
    goog.provide('ol.proj.Projection');
    goog.provide('ol.proj.ProjectionLike');
    goog.provide('ol.proj.Units');

    goog.require('goog.asserts');
    goog.require('goog.object');
    goog.require('ol');
    goog.require('ol.Extent');
    goog.require('ol.TransformFunction');
    goog.require('ol.extent');
    goog.require('ol.sphere.NORMAL');

    /**
     * A projection as {@link ol.proj.Projection}, SRS identifier string or
     * undefined.
     * @typedef {ol.proj.Projection|string|undefined} ol.proj.ProjectionLike
     * @api stable
     */
    ol.proj.ProjectionLike;

    /**
     * Projection units: `'degrees'`, `'ft'`, `'m'`, `'pixels'`, `'tile-pixels'` or
     * `'us-ft'`.
     * @enum {string}
     * @api stable
     */
    ol.proj.Units = {
      DEGREES: 'degrees',
      FEET: 'ft',
      METERS: 'm',
      PIXELS: 'pixels',
      TILE_PIXELS: 'tile-pixels',
      USFEET: 'us-ft'
    };

    /**
     * Meters per unit lookup table.
     * @const
     * @type {Object.<ol.proj.Units, number>}
     * @api stable
     */
    ol.proj.METERS_PER_UNIT = {};
    ol.proj.METERS_PER_UNIT[ol.proj.Units.DEGREES] =
        2 * Math.PI * ol.sphere.NORMAL.radius / 360;
    ol.proj.METERS_PER_UNIT[ol.proj.Units.FEET] = 0.3048;
    ol.proj.METERS_PER_UNIT[ol.proj.Units.METERS] = 1;
    ol.proj.METERS_PER_UNIT[ol.proj.Units.USFEET] = 1200 / 3937;

    /**
     * @classdesc
     * Projection definition class. One of these is created for each projection
     * supported in the application and stored in the {@link ol.proj} namespace.
     * You can use these in applications, but this is not required, as API params
     * and options use {@link ol.proj.ProjectionLike} which means the simple string
     * code will suffice.
     *
     * You can use {@link ol.proj.get} to retrieve the object for a particular
     * projection.
     *
     * The library includes definitions for `EPSG:4326` and `EPSG:3857`, together
     * with the following aliases:
     * * `EPSG:4326`: CRS:84, urn:ogc:def:crs:EPSG:6.6:4326,
     *     urn:ogc:def:crs:OGC:1.3:CRS84, urn:ogc:def:crs:OGC:2:84,
     *     http://www.opengis.net/gml/srs/epsg.xml#4326,
     *     urn:x-ogc:def:crs:EPSG:4326
     * * `EPSG:3857`: EPSG:102100, EPSG:102113, EPSG:900913,
     *     urn:ogc:def:crs:EPSG:6.18:3:3857,
     *     http://www.opengis.net/gml/srs/epsg.xml#3857
     *
     * If you use proj4js, aliases can be added using `proj4.defs()`; see
     * [documentation](https://github.com/proj4js/proj4js).
     *
     * @constructor
     * @param {olx.ProjectionOptions} options Projection options.
     * @struct
     * @api stable
     */
    ol.proj.Projection = function(options) {

      /**
       * @private
       * @type {string}
       */
      this.code_ = options.code;

      /**
       * @private
       * @type {ol.proj.Units}
       */
      this.units_ = /** @type {ol.proj.Units} */ (options.units);

      /**
       * @private
       * @type {ol.Extent}
       */
      this.extent_ = options.extent !== undefined ? options.extent : null;

      /**
       * @private
       * @type {ol.Extent}
       */
      this.worldExtent_ = options.worldExtent !== undefined ?
          options.worldExtent : null;

      /**
       * @private
       * @type {string}
       */
      this.axisOrientation_ = options.axisOrientation !== undefined ?
          options.axisOrientation : 'enu';

      /**
       * @private
       * @type {boolean}
       */
      this.global_ = options.global !== undefined ? options.global : false;

      /**
       * @private
       * @type {boolean}
       */
      this.canWrapX_ = !!(this.global_ && this.extent_);

      /**
      * @private
      * @type {function(number, ol.Coordinate):number}
      */
      this.getPointResolutionFunc_ = options.getPointResolution !== undefined ?
          options.getPointResolution : this.getPointResolution_;

      /**
       * @private
       * @type {ol.tilegrid.TileGrid}
       */
      this.defaultTileGrid_ = null;

      var projections = ol.proj.projections_;
      var code = options.code;
      goog.asserts.assert(code !== undefined,
          'Option "code" is required for constructing instance');
      if (ol.ENABLE_PROJ4JS && typeof proj4 == 'function' &&
          projections[code] === undefined) {
        var def = proj4.defs(code);
        if (def !== undefined) {
          if (def.axis !== undefined && options.axisOrientation === undefined) {
            this.axisOrientation_ = def.axis;
          }
          if (options.units === undefined) {
            var units = def.units;
            if (def.to_meter !== undefined) {
              if (units === undefined ||
                  ol.proj.METERS_PER_UNIT[units] === undefined) {
                units = def.to_meter.toString();
                ol.proj.METERS_PER_UNIT[units] = def.to_meter;
              }
            }
            this.units_ = units;
          }
          var currentCode, currentDef, currentProj, proj4Transform;
          for (currentCode in projections) {
            currentDef = proj4.defs(currentCode);
            if (currentDef !== undefined) {
              currentProj = ol.proj.get(currentCode);
              if (currentDef === def) {
                ol.proj.addEquivalentProjections([currentProj, this]);
              } else {
                proj4Transform = proj4(currentCode, code);
                ol.proj.addCoordinateTransforms(currentProj, this,
                    proj4Transform.forward, proj4Transform.inverse);
              }
            }
          }
        }
      }

    };

    /**
     * @return {boolean} The projection is suitable for wrapping the x-axis
     */
    ol.proj.Projection.prototype.canWrapX = function() {
      return this.canWrapX_;
    };

    /**
     * Get the code for this projection, e.g. 'EPSG:4326'.
     * @return {string} Code.
     * @api stable
     */
    ol.proj.Projection.prototype.getCode = function() {
      return this.code_;
    };

    /**
     * Get the validity extent for this projection.
     * @return {ol.Extent} Extent.
     * @api stable
     */
    ol.proj.Projection.prototype.getExtent = function() {
      return this.extent_;
    };

    /**
     * Get the units of this projection.
     * @return {ol.proj.Units} Units.
     * @api stable
     */
    ol.proj.Projection.prototype.getUnits = function() {
      return this.units_;
    };

    /**
     * Get the amount of meters per unit of this projection.  If the projection is
     * not configured with a units identifier, the return is `undefined`.
     * @return {number|undefined} Meters.
     * @api stable
     */
    ol.proj.Projection.prototype.getMetersPerUnit = function() {
      return ol.proj.METERS_PER_UNIT[this.units_];
    };

    /**
     * Get the world extent for this projection.
     * @return {ol.Extent} Extent.
     * @api
     */
    ol.proj.Projection.prototype.getWorldExtent = function() {
      return this.worldExtent_;
    };

    /**
     * Get the axis orientation of this projection.
     * Example values are:
     * enu - the default easting, northing, elevation.
     * neu - northing, easting, up - useful for "lat/long" geographic coordinates,
     *     or south orientated transverse mercator.
     * wnu - westing, northing, up - some planetary coordinate systems have
     *     "west positive" coordinate systems
     * @return {string} Axis orientation.
     */
    ol.proj.Projection.prototype.getAxisOrientation = function() {
      return this.axisOrientation_;
    };

    /**
     * Is this projection a global projection which spans the whole world?
     * @return {boolean} Whether the projection is global.
     * @api stable
     */
    ol.proj.Projection.prototype.isGlobal = function() {
      return this.global_;
    };

    /**
    * Set if the projection is a global projection which spans the whole world
    * @param {boolean} global Whether the projection is global.
    * @api stable
    */
    ol.proj.Projection.prototype.setGlobal = function(global) {
      this.global_ = global;
      this.canWrapX_ = !!(global && this.extent_);
    };

    /**
     * @return {ol.tilegrid.TileGrid} The default tile grid.
     */
    ol.proj.Projection.prototype.getDefaultTileGrid = function() {
      return this.defaultTileGrid_;
    };

    /**
     * @param {ol.tilegrid.TileGrid} tileGrid The default tile grid.
     */
    ol.proj.Projection.prototype.setDefaultTileGrid = function(tileGrid) {
      this.defaultTileGrid_ = tileGrid;
    };

    /**
     * Set the validity extent for this projection.
     * @param {ol.Extent} extent Extent.
     * @api stable
     */
    ol.proj.Projection.prototype.setExtent = function(extent) {
      this.extent_ = extent;
      this.canWrapX_ = !!(this.global_ && extent);
    };

    /**
     * Set the world extent for this projection.
     * @param {ol.Extent} worldExtent World extent
     *     [minlon, minlat, maxlon, maxlat].
     * @api
     */
    ol.proj.Projection.prototype.setWorldExtent = function(worldExtent) {
      this.worldExtent_ = worldExtent;
    };

    /**
    * Set the getPointResolution function for this projection.
    * @param {function(number, ol.Coordinate):number} func Function
    * @api
    */
    ol.proj.Projection.prototype.setGetPointResolution = function(func) {
      this.getPointResolutionFunc_ = func;
    };

    /**
    * Default version.
    * Get the resolution of the point in degrees or distance units.
    * For projections with degrees as the unit this will simply return the
    * provided resolution. For other projections the point resolution is
    * estimated by transforming the 'point' pixel to EPSG:4326,
    * measuring its width and height on the normal sphere,
    * and taking the average of the width and height.
    * @param {number} resolution Nominal resolution in projection units.
    * @param {ol.Coordinate} point Point to find adjusted resolution at.
    * @return {number} Point resolution at point in projection units.
    * @private
    */
    ol.proj.Projection.prototype.getPointResolution_ = function(resolution, point) {
      var units = this.getUnits();
      Iif (units == ol.proj.Units.DEGREES) {
        return resolution;
      } else {
        // Estimate point resolution by transforming the center pixel to EPSG:4326,
        // measuring its width and height on the normal sphere, and taking the
        // average of the width and height.
        var toEPSG4326 = ol.proj.getTransformFromProjections(
            this, ol.proj.get('EPSG:4326'));
        var vertices = [
          point[0] - resolution / 2, point[1],
          point[0] + resolution / 2, point[1],
          point[0], point[1] - resolution / 2,
          point[0], point[1] + resolution / 2
        ];
        vertices = toEPSG4326(vertices, vertices, 2);
        var width = ol.sphere.NORMAL.haversineDistance(
            vertices.slice(0, 2), vertices.slice(2, 4));
        var height = ol.sphere.NORMAL.haversineDistance(
            vertices.slice(4, 6), vertices.slice(6, 8));
        var pointResolution = (width + height) / 2;
        var metersPerUnit = this.getMetersPerUnit();
        if (metersPerUnit !== undefined) {
          pointResolution /= metersPerUnit;
        }
        return pointResolution;
      }
    };

    /**
     * Get the resolution of the point in degrees or distance units.
     * For projections with degrees as the unit this will simply return the
     * provided resolution. The default for other projections is to estimate
     * the point resolution by transforming the 'point' pixel to EPSG:4326,
     * measuring its width and height on the normal sphere,
     * and taking the average of the width and height.
     * An alternative implementation may be given when constructing a
     * projection. For many local projections,
     * such a custom function will return the resolution unchanged.
     * @param {number} resolution Resolution in projection units.
     * @param {ol.Coordinate} point Point.
     * @return {number} Point resolution in projection units.
     * @api
     */
    ol.proj.Projection.prototype.getPointResolution = function(resolution, point) {
      return this.getPointResolutionFunc_(resolution, point);
    };

    /**
     * @private
     * @type {Object.<string, ol.proj.Projection>}
     */
    ol.proj.projections_ = {};

    /**
     * @private
     * @type {Object.<string, Object.<string, ol.TransformFunction>>}
     */
    ol.proj.transforms_ = {};

    /**
     * Registers transformation functions that don't alter coordinates. Those allow
     * to transform between projections with equal meaning.
     *
     * @param {Array.<ol.proj.Projection>} projections Projections.
     * @api
     */
    ol.proj.addEquivalentProjections = function(projections) {
      ol.proj.addProjections(projections);
      projections.forEach(function(source) {
        projections.forEach(function(destination) {
          if (source !== destination) {
            ol.proj.addTransform(source, destination, ol.proj.cloneTransform);
          }
        });
      });
    };

    /**
     * Registers transformation functions to convert coordinates in any projection
     * in projection1 to any projection in projection2.
     *
     * @param {Array.<ol.proj.Projection>} projections1 Projections with equal
     *     meaning.
     * @param {Array.<ol.proj.Projection>} projections2 Projections with equal
     *     meaning.
     * @param {ol.TransformFunction} forwardTransform Transformation from any
     *   projection in projection1 to any projection in projection2.
     * @param {ol.TransformFunction} inverseTransform Transform from any projection
     *   in projection2 to any projection in projection1..
     */
    ol.proj.addEquivalentTransforms =
        function(projections1, projections2, forwardTransform, inverseTransform) {
      projections1.forEach(function(projection1) {
        projections2.forEach(function(projection2) {
          ol.proj.addTransform(projection1, projection2, forwardTransform);
          ol.proj.addTransform(projection2, projection1, inverseTransform);
        });
      });
    };

    /**
     * Add a Projection object to the list of supported projections that can be
     * looked up by their code.
     *
     * @param {ol.proj.Projection} projection Projection instance.
     * @api stable
     */
    ol.proj.addProjection = function(projection) {
      ol.proj.projections_[projection.getCode()] = projection;
      ol.proj.addTransform(projection, projection, ol.proj.cloneTransform);
    };

    /**
     * @param {Array.<ol.proj.Projection>} projections Projections.
     */
    ol.proj.addProjections = function(projections) {
      var addedProjections = [];
      projections.forEach(function(projection) {
        addedProjections.push(ol.proj.addProjection(projection));
      });
    };

    /**
     * FIXME empty description for jsdoc
     */
    ol.proj.clearAllProjections = function() {
      ol.proj.projections_ = {};
      ol.proj.transforms_ = {};
    };

    /**
     * @param {ol.proj.Projection|string|undefined} projection Projection.
     * @param {string} defaultCode Default code.
     * @return {ol.proj.Projection} Projection.
     */
    ol.proj.createProjection = function(projection, defaultCode) {
      if (!projection) {
        return ol.proj.get(defaultCode);
      } else if (goog.isString(projection)) {
        return ol.proj.get(projection);
      } else {
        goog.asserts.assertInstanceof(projection, ol.proj.Projection,
            'projection should be an ol.proj.Projection');
        return projection;
      }
    };

    /**
     * Registers a conversion function to convert coordinates from the source
     * projection to the destination projection.
     *
     * @param {ol.proj.Projection} source Source.
     * @param {ol.proj.Projection} destination Destination.
     * @param {ol.TransformFunction} transformFn Transform.
     */
    ol.proj.addTransform = function(source, destination, transformFn) {
      var sourceCode = source.getCode();
      var destinationCode = destination.getCode();
      var transforms = ol.proj.transforms_;
      if (!goog.object.containsKey(transforms, sourceCode)) {
        transforms[sourceCode] = {};
      }
      transforms[sourceCode][destinationCode] = transformFn;
    };

    /**
     * Registers coordinate transform functions to convert coordinates between the
     * source projection and the destination projection.
     * The forward and inverse functions convert coordinate pairs; this function
     * converts these into the functions used internally which also handle
     * extents and coordinate arrays.
     *
     * @param {ol.proj.ProjectionLike} source Source projection.
     * @param {ol.proj.ProjectionLike} destination Destination projection.
     * @param {function(ol.Coordinate): ol.Coordinate} forward The forward transform
     *     function (that is, from the source projection to the destination
     *     projection) that takes a {@link ol.Coordinate} as argument and returns
     *     the transformed {@link ol.Coordinate}.
     * @param {function(ol.Coordinate): ol.Coordinate} inverse The inverse transform
     *     function (that is, from the destination projection to the source
     *     projection) that takes a {@link ol.Coordinate} as argument and returns
     *     the transformed {@link ol.Coordinate}.
     * @api stable
     */
    ol.proj.addCoordinateTransforms =
        function(source, destination, forward, inverse) {
      var sourceProj = ol.proj.get(source);
      var destProj = ol.proj.get(destination);
      ol.proj.addTransform(sourceProj, destProj,
          ol.proj.createTransformFromCoordinateTransform(forward));
      ol.proj.addTransform(destProj, sourceProj,
          ol.proj.createTransformFromCoordinateTransform(inverse));
    };

    /**
     * Creates a {@link ol.TransformFunction} from a simple 2D coordinate transform
     * function.
     * @param {function(ol.Coordinate): ol.Coordinate} transform Coordinate
     *     transform.
     * @return {ol.TransformFunction} Transform function.
     */
    ol.proj.createTransformFromCoordinateTransform = function(transform) {
      return (
          /**
           * @param {Array.<number>} input Input.
           * @param {Array.<number>=} opt_output Output.
           * @param {number=} opt_dimension Dimension.
           * @return {Array.<number>} Output.
           */
          function(input, opt_output, opt_dimension) {
            var length = input.length;
            var dimension = opt_dimension !== undefined ? opt_dimension : 2;
            var output = opt_output !== undefined ? opt_output : new Array(length);
            var point, i, j;
            for (i = 0; i < length; i += dimension) {
              point = transform([input[i], input[i + 1]]);
              output[i] = point[0];
              output[i + 1] = point[1];
              for (j = dimension - 1; j >= 2; --j) {
                output[i + j] = input[i + j];
              }
            }
            return output;
          });
    };

    /**
     * Unregisters the conversion function to convert coordinates from the source
     * projection to the destination projection.  This method is used to clean up
     * cached transforms during testing.
     *
     * @param {ol.proj.Projection} source Source projection.
     * @param {ol.proj.Projection} destination Destination projection.
     * @return {ol.TransformFunction} transformFn The unregistered transform.
     */
    ol.proj.removeTransform = function(source, destination) {
      var sourceCode = source.getCode();
      var destinationCode = destination.getCode();
      var transforms = ol.proj.transforms_;
      goog.asserts.assert(sourceCode in transforms,
          'sourceCode should be in transforms');
      goog.asserts.assert(destinationCode in transforms[sourceCode],
          'destinationCode should be in transforms of sourceCode');
      var transform = transforms[sourceCode][destinationCode];
      delete transforms[sourceCode][destinationCode];
      if (goog.object.isEmpty(transforms[sourceCode])) {
        delete transforms[sourceCode];
      }
      return transform;
    };

    /**
     * Transforms a coordinate from longitude/latitude to a different projection.
     * @param {ol.Coordinate} coordinate Coordinate as longitude and latitude, i.e.
     *     an array with longitude as 1st and latitude as 2nd element.
     * @param {ol.proj.ProjectionLike=} opt_projection Target projection. The
     *     default is Web Mercator, i.e. 'EPSG:3857'.
     * @return {ol.Coordinate} Coordinate projected to the target projection.
     * @api stable
     */
    ol.proj.fromLonLat = function(coordinate, opt_projection) {
      return ol.proj.transform(coordinate, 'EPSG:4326',
          opt_projection !== undefined ? opt_projection : 'EPSG:3857');
    };

    /**
     * Transforms a coordinate to longitude/latitude.
     * @param {ol.Coordinate} coordinate Projected coordinate.
     * @param {ol.proj.ProjectionLike=} opt_projection Projection of the coordinate.
     *     The default is Web Mercator, i.e. 'EPSG:3857'.
     * @return {ol.Coordinate} Coordinate as longitude and latitude, i.e. an array
     *     with longitude as 1st and latitude as 2nd element.
     * @api stable
     */
    ol.proj.toLonLat = function(coordinate, opt_projection) {
      return ol.proj.transform(coordinate,
          opt_projection !== undefined ? opt_projection : 'EPSG:3857', 'EPSG:4326');
    };

    /**
     * Fetches a Projection object for the code specified.
     *
     * @param {ol.proj.ProjectionLike} projectionLike Either a code string which is
     *     a combination of authority and identifier such as "EPSG:4326", or an
     *     existing projection object, or undefined.
     * @return {ol.proj.Projection} Projection object, or null if not in list.
     * @api stable
     */
    ol.proj.get = function(projectionLike) {
      var projection;
      if (projectionLike instanceof ol.proj.Projection) {
        projection = projectionLike;
      } else if (goog.isString(projectionLike)) {
        var code = projectionLike;
        projection = ol.proj.projections_[code];
        if (ol.ENABLE_PROJ4JS && projection === undefined &&
            typeof proj4 == 'function' && proj4.defs(code) !== undefined) {
          projection = new ol.proj.Projection({code: code});
          ol.proj.addProjection(projection);
        }
      } else {
        projection = null;
      }
      return projection;
    };

    /**
     * Checks if two projections are the same, that is every coordinate in one
     * projection does represent the same geographic point as the same coordinate in
     * the other projection.
     *
     * @param {ol.proj.Projection} projection1 Projection 1.
     * @param {ol.proj.Projection} projection2 Projection 2.
     * @return {boolean} Equivalent.
     */
    ol.proj.equivalent = function(projection1, projection2) {
      if (projection1 === projection2) {
        return true;
      } else if (projection1.getCode() === projection2.getCode()) {
        return projection1.getUnits() === projection2.getUnits();
      } else {
        var transformFn = ol.proj.getTransformFromProjections(
            projection1, projection2);
        return transformFn === ol.proj.cloneTransform;
      }
    };

    /**
     * Given the projection-like objects, searches for a transformation
     * function to convert a coordinates array from the source projection to the
     * destination projection.
     *
     * @param {ol.proj.ProjectionLike} source Source.
     * @param {ol.proj.ProjectionLike} destination Destination.
     * @return {ol.TransformFunction} Transform function.
     * @api stable
     */
    ol.proj.getTransform = function(source, destination) {
      var sourceProjection = ol.proj.get(source);
      var destinationProjection = ol.proj.get(destination);
      return ol.proj.getTransformFromProjections(
          sourceProjection, destinationProjection);
    };

    /**
     * Searches in the list of transform functions for the function for converting
     * coordinates from the source projection to the destination projection.
     *
     * @param {ol.proj.Projection} sourceProjection Source Projection object.
     * @param {ol.proj.Projection} destinationProjection Destination Projection
     *     object.
     * @return {ol.TransformFunction} Transform function.
     */
    ol.proj.getTransformFromProjections =
        function(sourceProjection, destinationProjection) {
      var transforms = ol.proj.transforms_;
      var sourceCode = sourceProjection.getCode();
      var destinationCode = destinationProjection.getCode();
      var transform;
      Eif (goog.object.containsKey(transforms, sourceCode) &&
          goog.object.containsKey(transforms[sourceCode], destinationCode)) {
        transform = transforms[sourceCode][destinationCode];
      }
      Iif (transform === undefined) {
        goog.asserts.assert(transform !== undefined, 'transform should be defined');
        transform = ol.proj.identityTransform;
      }
      return transform;
    };

    /**
     * @param {Array.<number>} input Input coordinate array.
     * @param {Array.<number>=} opt_output Output array of coordinate values.
     * @param {number=} opt_dimension Dimension.
     * @return {Array.<number>} Input coordinate array (same array as input).
     */
    ol.proj.identityTransform = function(input, opt_output, opt_dimension) {
      if (opt_output !== undefined && input !== opt_output) {
        // TODO: consider making this a warning instead
        goog.asserts.fail('This should not be used internally.');
        for (var i = 0, ii = input.length; i < ii; ++i) {
          opt_output[i] = input[i];
        }
        input = opt_output;
      }
      return input;
    };

    /**
     * @param {Array.<number>} input Input coordinate array.
     * @param {Array.<number>=} opt_output Output array of coordinate values.
     * @param {number=} opt_dimension Dimension.
     * @return {Array.<number>} Output coordinate array (new array, same coordinate
     *     values).
     */
    ol.proj.cloneTransform = function(input, opt_output, opt_dimension) {
      var output;
      Iif (opt_output !== undefined) {
        for (var i = 0, ii = input.length; i < ii; ++i) {
          opt_output[i] = input[i];
        }
        output = opt_output;
      } else {
        output = input.slice();
      }
      return output;
    };

    /**
     * Transforms a coordinate from source projection to destination projection.
     * This returns a new coordinate (and does not modify the original).
     *
     * See {@link ol.proj.transformExtent} for extent transformation.
     * See the transform method of {@link ol.geom.Geometry} and its subclasses for
     * geometry transforms.
     *
     * @param {ol.Coordinate} coordinate Coordinate.
     * @param {ol.proj.ProjectionLike} source Source projection-like.
     * @param {ol.proj.ProjectionLike} destination Destination projection-like.
     * @return {ol.Coordinate} Coordinate.
     * @api stable
     */
    ol.proj.transform = function(coordinate, source, destination) {
      var transformFn = ol.proj.getTransform(source, destination);
      return transformFn(coordinate, undefined, coordinate.length);
    };

    /**
     * Transforms an extent from source projection to destination projection.  This
     * returns a new extent (and does not modify the original).
     *
     * @param {ol.Extent} extent The extent to transform.
     * @param {ol.proj.ProjectionLike} source Source projection-like.
     * @param {ol.proj.ProjectionLike} destination Destination projection-like.
     * @return {ol.Extent} The transformed extent.
     * @api stable
     */
    ol.proj.transformExtent = function(extent, source, destination) {
      var transformFn = ol.proj.getTransform(source, destination);
      return ol.extent.applyTransform(extent, transformFn);
    };

    /**
     * Transforms the given point to the destination projection.
     *
     * @param {ol.Coordinate} point Point.
     * @param {ol.proj.Projection} sourceProjection Source projection.
     * @param {ol.proj.Projection} destinationProjection Destination projection.
     * @return {ol.Coordinate} Point.
     */
    ol.proj.transformWithProjections =
        function(point, sourceProjection, destinationProjection) {
      var transformFn = ol.proj.getTransformFromProjections(
          sourceProjection, destinationProjection);
      return transformFn(point);
    };